package be.jeffcheasey88.peeratcode.parser.java;

import be.jeffcheasey88.peeratcode.parser.Token;

public class Value extends JavaElement{

	private Token token;
	
	private Value value;
	
	protected Value(){}
	
	public Value(Token token){
		this.token = token;
		System.out.println(this);
	}
	
	public void switchInto(Value value){
		this.value = value;
	}
	
	public Value get(){
		return this.value;
	}
	
	@Override
	public String toString(){
		return "[Value="+token+", val="+((value == null ? "null":value.getClass().getSimpleName()))+"]";
	}
	
	public static class BiValue extends Value{
		
		private Value left;
		private Value right;
		
		private Token type; //make a concat later
		
		public BiValue(Value left, Value right, Token operation){
			this.left = left;
			this.right = right;
			
			this.type = operation;
			System.out.println(this);
		}
		
		@Override
		public String toString(){
			return "[BiValue left="+left+" type="+type+" right="+right+"]";
		}
	}
	
	public static class TriValue extends Value{
		
		public TriValue(){
			
		}
	}
}
